// This file may be redistributed and modified only under the terms of
// the GNU Lesser General Public License (See COPYING for details).
// Copyright 2000-2001 Aloril.
// Copyright 2001-2004 Al Riddoch.
// Automatically generated using gen_cpp.py.

#include <Atlas/Objects/objectFactory.h>
#include <Atlas/Objects/Entity.h>
#include <Atlas/Objects/Operation.h>

namespace Atlas { namespace Objects { 

int enumMax = 38;

using Atlas::Message::Element;
using Atlas::Message::ListType;
using Atlas::Message::MapType;

NoSuchFactoryException::~NoSuchFactoryException() throw ()
{
}

std::map<const std::string, Root> objectDefinitions;
Factories objectFactory;

class AddFactories {
public:
    AddFactories();
} addThemHere;

AddFactories::AddFactories()
{

    objectFactory.addFactory("root", 
        (FactoryMethod)&Root::factory);

    objectFactory.addFactory("root_entity", 
        (FactoryMethod)&Entity::RootEntity::factory);

    objectFactory.addFactory("admin_entity", 
        (FactoryMethod)&Entity::AdminEntity::factory);

    objectFactory.addFactory("account", 
        (FactoryMethod)&Entity::Account::factory);

    objectFactory.addFactory("player", 
        (FactoryMethod)&Entity::Player::factory);

    objectFactory.addFactory("admin", 
        (FactoryMethod)&Entity::Admin::factory);

    objectFactory.addFactory("game", 
        (FactoryMethod)&Entity::Game::factory);

    objectFactory.addFactory("game_entity", 
        (FactoryMethod)&Entity::GameEntity::factory);

    objectFactory.addFactory("root_operation", 
        (FactoryMethod)&Operation::RootOperation::factory);

    objectFactory.addFactory("action", 
        (FactoryMethod)&Operation::Action::factory);

    objectFactory.addFactory("create", 
        (FactoryMethod)&Operation::Create::factory);

    objectFactory.addFactory("combine", 
        (FactoryMethod)&Operation::Combine::factory);

    objectFactory.addFactory("divide", 
        (FactoryMethod)&Operation::Divide::factory);

    objectFactory.addFactory("communicate", 
        (FactoryMethod)&Operation::Communicate::factory);

    objectFactory.addFactory("talk", 
        (FactoryMethod)&Operation::Talk::factory);

    objectFactory.addFactory("delete", 
        (FactoryMethod)&Operation::Delete::factory);

    objectFactory.addFactory("set", 
        (FactoryMethod)&Operation::Set::factory);

    objectFactory.addFactory("move", 
        (FactoryMethod)&Operation::Move::factory);

    objectFactory.addFactory("get", 
        (FactoryMethod)&Operation::Get::factory);

    objectFactory.addFactory("perceive", 
        (FactoryMethod)&Operation::Perceive::factory);

    objectFactory.addFactory("look", 
        (FactoryMethod)&Operation::Look::factory);

    objectFactory.addFactory("listen", 
        (FactoryMethod)&Operation::Listen::factory);

    objectFactory.addFactory("sniff", 
        (FactoryMethod)&Operation::Sniff::factory);

    objectFactory.addFactory("touch", 
        (FactoryMethod)&Operation::Touch::factory);

    objectFactory.addFactory("login", 
        (FactoryMethod)&Operation::Login::factory);

    objectFactory.addFactory("logout", 
        (FactoryMethod)&Operation::Logout::factory);

    objectFactory.addFactory("imaginary", 
        (FactoryMethod)&Operation::Imaginary::factory);

    objectFactory.addFactory("info", 
        (FactoryMethod)&Operation::Info::factory);

    objectFactory.addFactory("perception", 
        (FactoryMethod)&Operation::Perception::factory);

    objectFactory.addFactory("sight", 
        (FactoryMethod)&Operation::Sight::factory);

    objectFactory.addFactory("appearance", 
        (FactoryMethod)&Operation::Appearance::factory);

    objectFactory.addFactory("disappearance", 
        (FactoryMethod)&Operation::Disappearance::factory);

    objectFactory.addFactory("sound", 
        (FactoryMethod)&Operation::Sound::factory);

    objectFactory.addFactory("smell", 
        (FactoryMethod)&Operation::Smell::factory);

    objectFactory.addFactory("feel", 
        (FactoryMethod)&Operation::Feel::factory);

    objectFactory.addFactory("error", 
        (FactoryMethod)&Operation::Error::factory);

    objectFactory.addFactory("anonymous", 
        (FactoryMethod)&Entity::Anonymous::factory);
}

bool Factories::hasFactory(const std::string& name)
{
    FactoryMap::const_iterator I = m_factories.find(name);
    return I != m_factories.end();
}
    
Root Factories::createObject(const std::string& name)
{
    FactoryMap::const_iterator I = m_factories.find(name);
    if (I == m_factories.end()) {
        throw NoSuchFactoryException(name);
    } else {
        return (*I).second();
    }
}
    
std::list<std::string> Factories::getKeys()
{
    std::list<std::string> keys;
    for (FactoryMap::const_iterator I = m_factories.begin();
         I != m_factories.end(); I++) {
        keys.push_back(I->first);
    }
    return keys;
}
    
int Factories::addFactory(const std::string& name, FactoryMethod method)
{
    m_factories[name] = method;
    return ++enumMax;
}

Root messageElement2ClassObject(const MapType & mobj)
{
    Root obj;

    // is this instance of entity or operation?
    MapType::const_iterator I = mobj.find("objtype");
    bool is_instance = false;
    if(I != mobj.end() && I->second.isString()) {
        const std::string & objtype = I->second.asString();
        if(objtype == "op" || objtype == "obj" || objtype == "object") {
            // get parent
            I = mobj.find("parents");
            if(I != mobj.end()) {
                const ListType & parents_lst = I->second.asList();
                if(parents_lst.size()>=1 && parents_lst.front().isString()) {
                    const std::string & parent = parents_lst.front().asString();
                    // objtype and parent ok, try to create it:
                    if(objectFactory.hasFactory(parent)) {
                        obj = objectFactory.createObject(parent);
                        is_instance = true;
                    } // got object
                    // FIXME We might want to do something different here.
                } // parent list ok?
            } // has parent attr?
        } // has known objtype
    } // has objtype attr
    if (!is_instance) {
        // Should we really use factory? Why not just instantiate by hand?
        obj = objectFactory.createObject("anonymous");
    } // not instance
    for (I = mobj.begin(); I != mobj.end(); I++) {
        obj->setAttr(I->first, I->second);
    }
    return obj;
}

} } // namespace Atlas::Objects
